/*********************************************************************
 *
 *      Example
 *
 ********************************************************************/
#include <plib.h>

//#pragma ICESEL = ICS_PGx2, JTAGEN = OFF
#pragma config FPLLIDIV = DIV_2, FPLLMUL = MUL_20, FPLLODIV = DIV_2
#pragma config FPBDIV = DIV_1
#pragma config POSCMOD = OFF, FSOSCEN = OFF, FNOSC = FRCPLL 
#pragma config FWDTEN = OFF

#define SYS_FREQ 			(40000000L)
#define PB_FREQ				(40000000L)

// interval interrupt frequency
#define TIMER1_FREQ			50

#define C1_INPUT_AN4 0
#define C1_INPUT_AN3 1
#define C1_INPUT_AN2 2

//#define IDX_MSK 0xFFF
//#define BUF_SIZ (IDX_MSK + 1)
//#define MAX_CH 9

#define IDX_MSK 0x7FF
#define BUF_SIZ (IDX_MSK + 1)
#define TRG_POS ((IDX_MSK + 1) / 2)
#define MAX_CH 3

//volatile unsigned char *CrntCapBuf;
volatile unsigned int CapIdx;
volatile unsigned int CapCnt = 0;

typedef struct
{
	unsigned char CapBuf[BUF_SIZ];
	unsigned int TrgIdx;
} t_CapSys;

volatile t_CapSys CapSys[3];

volatile t_CapSys *CrntCapSys = CapSys;

typedef struct
{
	int ADPreScale;
	int TimerPreset;
	int TimerPreScale;
	int TimerCountShift;
	int BufferAdj;
	int InputCaptureDelay;
}	t_SwpCtl;

t_SwpCtl SwpCtlBuf[] =
{
	0,BUF_SIZ - 1,T3_PS_1_32,0,16,1,
	1,BUF_SIZ - 1,T3_PS_1_64,0,16,2,
	3,8191,T3_PS_1_64,1,16,20,
	7,16383,T3_PS_1_64,2,16,20,
	15,8191,T3_PS_1_256,1,16,20,
	31,16383,T3_PS_1_256,2,16,20
};

t_SwpCtl *CrtSwpCtl = &SwpCtlBuf[0];

typedef struct
{
	int AdChnSelect;
} t_MsrChn;

t_MsrChn MsrChnBuf[] = 
{
	ADC_CH0_NEG_SAMPLEA_NVREF | ADC_CH0_POS_SAMPLEA_AN4,	//CH1
	ADC_CH0_NEG_SAMPLEA_NVREF | ADC_CH0_POS_SAMPLEA_AN3,	//CH2
	ADC_CH0_NEG_SAMPLEA_NVREF | ADC_CH0_POS_SAMPLEA_AN2,	//CH3
	ADC_CH0_NEG_SAMPLEA_NVREF | ADC_CH0_POS_SAMPLEA_AN1,	//CH4
	ADC_CH0_NEG_SAMPLEA_NVREF | ADC_CH0_POS_SAMPLEA_AN0,	//CH5
	ADC_CH0_NEG_SAMPLEA_NVREF | ADC_CH0_POS_SAMPLEA_AN9,	//CH6
	ADC_CH0_NEG_SAMPLEA_NVREF | ADC_CH0_POS_SAMPLEA_AN10,	//CH7
	ADC_CH0_NEG_SAMPLEA_NVREF | ADC_CH0_POS_SAMPLEA_AN11,	//CH8
	ADC_CH0_NEG_SAMPLEA_NVREF | ADC_CH0_POS_SAMPLEA_AN12	//CH9
};

t_MsrChn *CrtMsrChn = &MsrChnBuf[0];

typedef struct
{
	int Cmp1ChnSelect;
} t_TrgChn;

t_TrgChn TrgChnBuf[] = 
{
	CMP_ENABLE | CMP_OUTPUT_ENABLE | CMP_OUTPUT_NONINVERT | CMP_EVENT_NONE | C1_INPUT_AN4,
	CMP_ENABLE | CMP_OUTPUT_ENABLE | CMP_OUTPUT_NONINVERT | CMP_EVENT_NONE | C1_INPUT_AN3,
	CMP_ENABLE | CMP_OUTPUT_ENABLE | CMP_OUTPUT_NONINVERT | CMP_EVENT_NONE | C1_INPUT_AN2
};

t_TrgChn *CrtTrgChn = &TrgChnBuf[0];

typedef struct
{
	int Sweep;					//sweep speed
	char ChnEnable[MAX_CH];		//mesure channel
	int TrgChn;					//channel for trigger
//	int TrgPos;					//trigger position on buffer
	int DspEnsmall;				//Ensmall ratio for display 1 to 16 
	int DspTopIdx;				//display top buffer index
	int TriggerLevel;			//trigger level
	int GndLevel;				//ground level
	int DspOffset[MAX_CH];		//display offset
	int TriggerPolarity;		//trigger polarity
	int DataHold;				//hold all the captured data
}	t_Setting;

volatile t_Setting Setting;
volatile t_Setting NextSetting;

volatile unsigned int MesuredGndLevel;

volatile unsigned int AdResult;	// conversion result as read from result buffer

// interval counter
volatile int SynCnt = 0;

void __ISR(_TIMER_1_VECTOR, IPL2SOFT) Timer1Handler(void)
{
    // clear the interrupt flag
    mT1ClearIntFlag();
	SynCnt++;
}

void Sync(int Cnt)
{
	SynCnt -= Cnt;
	while(SynCnt < 0);
}

void __ISR(_ADC_VECTOR, IPL4SOFT) Adc10Handler(void)
{
	volatile int dmy;
	unsigned char *dp;

	dp = (unsigned char *)&CrntCapSys->CapBuf[CapIdx];

	if(AD1CON2bits.BUFS)
	{
		*dp++ = ADC1BUF0 >> 2;
		*dp++ = ADC1BUF1 >> 2;
		*dp++ = ADC1BUF2 >> 2;
		*dp++ = ADC1BUF3 >> 2;
		*dp++ = ADC1BUF4 >> 2;
		*dp++ = ADC1BUF5 >> 2;
		*dp++ = ADC1BUF6 >> 2;
		*dp++ = ADC1BUF7 >> 2;
	}
	else
	{
		*dp++ = ADC1BUF8 >> 2;
		*dp++ = ADC1BUF9 >> 2;
		*dp++ = ADC1BUFA >> 2;
		*dp++ = ADC1BUFB >> 2;
		*dp++ = ADC1BUFC >> 2;
		*dp++ = ADC1BUFD >> 2;
		*dp++ = ADC1BUFE >> 2;
		*dp++ = ADC1BUFF >> 2;
	}
	CapIdx += 8;
	CapIdx &= IDX_MSK;

//	if(CapIdx < 512)
//	{
//		LATBSET = BIT_5;
//	}
//	else
//	{
//		LATBCLR = BIT_5;
//	}

	CapCnt++;

	mAD1ClearIntFlag();
//	IFS1CLR = _IFS1_AD1IF_MASK;
//	IFS0bits.AD1IF = 0;	//Clear ADC interrupt flag
}

void WaitCap(int Times)
{
	Times >>= 3;
	CapCnt = 0;
	while(CapCnt < Times);
}

void T1Init(void)
{
    OpenTimer1(T1_ON | T1_SOURCE_INT | T1_PS_1_256, (PB_FREQ/256/TIMER1_FREQ));
    ConfigIntTimer1(T1_INT_ON | T1_INT_PRIOR_2);
}

//
//	timer 2 for PWM
//
void T2Init(void)
{
	//setup timer 2
	TMR2 = 0;
	PR2 = 255;
	T2CON
		= T2_ON				//power on timer 2
		| T2_PS_1_1			//prescale 1/1
		| T2_SOURCE_INT;	//use PB clock 

	//setup PWM 3
	OC3RS = 128;			//OC2 duty cycle
	OC3CON
		= OC_ON				//power on OC3
		| OC_TIMER2_SRC		//use timer 2
		| OC_PWM_FAULT_PIN_DISABLE;	//simple PWM
//	RPA3R = 5;				//allocate OC3 out on PA3
	RPB14R = 5;				//allocate OC3 out on PA3

	//setup PWM 4
	OC4RS = 10;				//OC4 duty cycle
	OC4CON
		= OC_ON				//power on OC4
		| OC_TIMER2_SRC		//use timer 3
		| OC_PWM_FAULT_PIN_DISABLE;	//simple PWM
	RPA2R = 5;				//allocate OC4 out on PA2
}

//
//	timer 3 for capture
//
void T3Init()
{
	//setup timer 2
	TMR3 = 0;
	PR3 = IDX_MSK;			//runing in cap buffer index value
	T3CON
		= T3_ON				//power on timer 2
		| T3_PS_1_32		//prescale 1/32 (count up each AD conversion)
		| T3_SOURCE_INT;	//use PB clock 

}

//
//	comparator 1 initialize
//	output compair result on RPB9 pin
//
void C1Init(void)
{
	//setup compairator
	CM1CON
		= CMP_ENABLE			// comparator on
		| CMP_OUTPUT_ENABLE		// drive a pin for output
		| CMP_OUTPUT_NONINVERT	// non invert output
		| CMP_EVENT_NONE		// no interrupt event
		| 0						// connect positive input to C1INA pin
		| 0;					//0 : select C1INB pin for negative input
								//1	: select C1INC pin for negative input
								//2	: select C1IND pin for negative input
								//3	: select internal IVref for negative input

	// allocate comparatro out put
	//RPB9R = 7;					//7 : RPB9 pin for Comparator 1 output		
	RPA3R = 7;						//7 : PA3 pin for Comparator 1 output		
}

//
//	setup input capture
//	capture timer 3 using rise edge of comparator 1 out (pin RPB9)
//
void IC2Init(int TrgPol)
{
	//set capture pin
	//IC2R = 4;					//allocate IC2 to RPB9
	IC2R = 0;					//allocate IC2 to RA3
	//if negative trigger
	if(TrgPol)
	{
		//start capture
		IC2CON 
			= IC_ON					//ON capture4 on
			| IC_IDLE_CON			//SIDL dont stop in idle mode 
			| IC_FEDGE_FALL			//ICFEDGE at first capture rise edge 
			| IC_CAP_16BIT			//IC32 use 16bit counter
			| IC_TIMER3_SRC			//ICTMR use timer 3
			| IC_INT_1CAPTURE		//ICI interrupt every 1 capture
			| IC_EVERY_RISE_EDGE;	//ICM capture every rise edge
	}
	else
	{
		//start capture
		IC2CON 
			= IC_ON					//ON capture4 on
			| IC_IDLE_CON			//SIDL dont stop in idle mode 
			| IC_FEDGE_FALL			//ICFEDGE at first capture rise edge 
			| IC_CAP_16BIT			//IC32 use 16bit counter
			| IC_TIMER3_SRC			//ICTMR use timer 3
			| IC_INT_1CAPTURE		//ICI interrupt every 1 capture
			| IC_EVERY_FALL_EDGE;	//ICM capture every fall edge
	}
}

//
//	wait edge capture
//
int IC2Wait(void)
{
	volatile int dmy;
	volatile int TrgIdx,i;
	int j;

	//skip buffer data
	while(IC2CONbits.ICBNE) dmy = IC2BUF;
	for(;;)
	{
		//wait capture
		for(j = 0;j != 500000;j++)
		{
			if(IC2CONbits.ICBNE) break;
		}
		if(j == 500000)
		{
			return CapIdx;
		}
		else
		{
			//read buffer
			TrgIdx = IC2BUF;
			for(i = 0;i < CrtSwpCtl->InputCaptureDelay;i++);
			if(! CM2CONbits.COUT)
			{
				TrgIdx >>= CrtSwpCtl->TimerCountShift;
				return TrgIdx;
			}
		}
	}
}

int Limit(int Val,int Min,int Max)
{
	if(Val < Min)
	{
		Val = Min;
	}
	if(Val > Max)
	{
		Val = Max;
	}
	return Val;
}

void RcvFunc(int Cmd,int Val)
{
	switch(Cmd)
	{
		case 1:
			NextSetting.Sweep = Limit(Val,0,5);
			break;
		case 5:
			NextSetting.DspEnsmall = Limit(Val,1,16);
			break;
		case 15:
			NextSetting.DspTopIdx = Limit(Val,0,4096);
			break;
		case 20:
			NextSetting.ChnEnable[Limit(Val,0,5)] = 1;
			break;
		case 21:
			NextSetting.ChnEnable[Limit(Val,0,5)] = 0;
			break;
		case 30:
			NextSetting.TriggerLevel = Limit(Val,0,255);
			break;
		case 31:
			NextSetting.TriggerPolarity = Limit(Val,0,1);
			break;
		case 32:
			NextSetting.DataHold = Limit(Val,0,1);
			break;
		case 40:
			NextSetting.GndLevel = Limit(Val,0,255);
			break;
		case 60:
			NextSetting.TrgChn = Limit(Val,0,2);
			break;

		default:
			break;
	}
}

void __ISR(_UART_1_VECTOR, IPL2SOFT) SerialHandler(void)
{
	static unsigned char RcvBuf[10];
	static int RcvIdx = 0;
	unsigned int Val;

    RcvBuf[RcvIdx++] = U1RXREG;
	RcvIdx &= 3;

	IFS1bits.U1RXIF = 0;

	if(! RcvIdx)
	{
		if(RcvBuf[3] == 0xFF)
		{
			Val = RcvBuf[2];
			Val <<= 8;
			Val |= RcvBuf[1];
			RcvFunc(RcvBuf[0],Val);
		}
		else
		{
			RcvIdx = 3;
		}
	}
}

//
//	Initialize sereal port
//
void SioInit(void)
{
	RPB7R = 0b0001; //RB4=U1TX
	U1RXR = 0b0001; //U1RX=RB6
    UARTConfigure(UART1, UART_ENABLE_PINS_TX_RX_ONLY);
    UARTSetFifoMode(UART1, UART_INTERRUPT_ON_TX_NOT_FULL | UART_INTERRUPT_ON_RX_NOT_EMPTY);
    UARTSetLineControl(UART1, UART_DATA_SIZE_8_BITS | UART_PARITY_NONE | UART_STOP_BITS_1);
    UARTSetDataRate(UART1, PB_FREQ, 57600);
    UARTEnable(UART1, UART_ENABLE_FLAGS(UART_PERIPHERAL | UART_RX | UART_TX));

	//setting the interrupt
	IPC8 = 0b1000;
	IFS1bits.U1RXIF = 0;
	IEC1bits.U1RXIE = 1;


//    ConfigIntUART1(UART_RX_INT_EN | UART_INT_PR2);
}

//
//	Serial out
//
void SioOut(char mji)
{
	while(!UARTTransmitterIsReady(UART1));
	UARTSendDataByte(UART1, mji);
    while(!UARTTransmissionHasCompleted(UART1));
}

//
//	Initialize ADC
//
int AdcInit(void)
{
	AD1CON1
		= ADC_MODULE_OFF			//disable module
		| ADC_FORMAT_INTG			//set result format as int 16 bit
		| ADC_CLK_AUTO				//auto start conversion after sampling
		| ADC_AUTO_SAMPLING_ON;		//auto start sampling after conversion

	AD1CON2
		= ADC_VREF_AVDD_AVSS		//use AVss and AVdd for reference
		| ADC_OFFSET_CAL_DISABLE	//offset caliblation off
		| ADC_SCAN_OFF				//dont scan input pins
		| ADC_SAMPLES_PER_INT_8		//interrupt each 8 sample
		| ADC_ALT_BUF_ON			//use dual 8 word result buffer
		| ADC_ALT_INPUT_OFF;		//dont scan input pins

	AD1CON3
		= ADC_SAMPLE_TIME_3			//sample time in TAD
		| ADC_CONV_CLK_PB			//use PBCLK for ADC clock source. then ADCS is enabled
		| ADC_CONV_CLK_Tcy2;		//PBCLK devisor retio 1/2 (8 bits)

	AD1CHS
  		= ADC_CH0_NEG_SAMPLEA_NVREF	//AN1 for MUXA (-)
		| ADC_CH0_POS_SAMPLEA_AN4;	//AN5 for MUXB (+)

	AD1CSSL 
		= 0;						//no channel is scaned

	//settin input as analog. default all ANx pins are analog mode
	ANSELB = 0;						//default
	ANSELA = 0;						//default

	//setting the interrupt
	IPC5bits.AD1IP = 4;	//priority
	IPC5bits.AD1IS = 0;	//sub priorty
	IFS0bits.AD1IF = 0;	//Clear ADC interrupt flag
	IEC0bits.AD1IE = 1;	//Enable ADC interrupt

	//enable AD module and finish initialize
	AD1CON1bits.ON = 1;	//Enable ADC
}

//
//	change sweep speed setting
//
int SetSwpCtl(int SwpIdx)
{
	CrtSwpCtl = &SwpCtlBuf[SwpIdx];
	AD1CON3bits.ADCS = CrtSwpCtl->ADPreScale;
	PR3 = CrtSwpCtl->TimerPreset;
	T3CON	= T3_ON						//power on timer 2
			| CrtSwpCtl->TimerPreScale	//prescale 1/32 (count up each AD conversion)
			| T3_SOURCE_INT;			//use PB clock 
}

//
//	change mesure channel setting
//
int SetMsrChn(int Idx)
{
	CrtMsrChn = &MsrChnBuf[Idx];
	AD1CHS = CrtMsrChn->AdChnSelect;
}

//
//	change trigger channel setting
//
int SetTrgChn(int Idx)
{
	CrtTrgChn = &TrgChnBuf[Idx];
	CM1CON = CrtTrgChn->Cmp1ChnSelect;
}

//
//	old fassoned main loop
//
int main(void)
{
	unsigned int i,j;
//	unsigned int TrgIdx;		//trigger position in capture buffer
	unsigned int ChnIdx = 0;	//index of current convertiong channel
	unsigned int NextChnIdx = 0;//index of current convertiong channel

	// Configure the device for maximum performance
	SYSTEMConfig(SYS_FREQ, SYS_CFG_WAIT_STATES | SYS_CFG_PCACHE);
	// disable JTAG function
	mJTAGPortEnable(DEBUG_JTAGPORT_OFF);
	// set digital out
	TRISACLR = BIT_2 | BIT_4;
	TRISBCLR = BIT_4 | BIT_5 | BIT_7| BIT_8 | BIT_9 | BIT_10 | BIT_11 | BIT_14;
	
    // enable multi-vector interrupts
    INTEnableSystemMultiVectoredInt();

	SioInit();	//serial port
	T2Init();	//pwm
	T3Init();	//trigger timing counter
	C1Init();	//trigger comparator
	IC2Init(0);	//trigger capure
	AdcInit();	//convertor

	// prepair general setting
	Setting.TriggerLevel = 128;
	Setting.Sweep = 0;
	Setting.DspEnsmall = 2;
	Setting.DspTopIdx = 1024 - 128;
	Setting.TrgChn = 0;
	Setting.ChnEnable[0] = 0;
	Setting.ChnEnable[1] = 0;
	Setting.ChnEnable[2] = 0;
	Setting.ChnEnable[3] = 0;
	Setting.ChnEnable[4] = 0;
	Setting.GndLevel = 128;
	Setting.TriggerPolarity = 0; //positive

	NextSetting = Setting;

	// sync TMR 3 with wave capture
	AD1CON1bits.ON = 0;	//stop ADC
	TMR3 = 0;
	AD1CON1bits.ON = 1;	//run ADC

	for(;;)
	{
		// stop ADC
		AD1CON1bits.ON = 0;	//stop ADC

		// setup auto conversion
		CapIdx = 0;

		// setup next measure channel
		// next channel
		ChnIdx++;
		for(;;)
		{
			// indicate TX
			LATBINV = BIT_5;
			//update setting
			Setting = NextSetting;

			if(ChnIdx == MAX_CH)
			{
				ChnIdx = 0;
			} 
			if(Setting.ChnEnable[ChnIdx])
			{
				SetMsrChn(ChnIdx);
				CrntCapSys = &CapSys[ChnIdx];
				break;
			}
			else
			{
				ChnIdx++;
			}
		}

		//if not data hold, start conversion
		if(! Setting.DataHold)
		{
			OC4RS = MesuredGndLevel + Setting.TriggerLevel - 128;
			OC3RS = Setting.GndLevel;

			// setup sweep selection
			SetSwpCtl(Setting.Sweep);
			SetTrgChn(Setting.TrgChn);
	
			//set trgger polarity
			IC2Init(Setting.TriggerPolarity);

			// sync TMR 3 and ADC interrupt
			TMR3 = 0;			//reset timer
			AD1CON1bits.ON = 1;	//run ADC
	
			/////////////////////////
			// start conversion
			/////////////////////////
			IEC0bits.AD1IE = 1;
	
			// wait capture to the trigger position (1st half)
			//WaitCap(Setting.TrgPos);
			WaitCap(1023);
	
			// wait trigger
			CrntCapSys->TrgIdx = IC2Wait();
	
			// wait capture to the end position (2nd half)
			int tmp;
			tmp = BUF_SIZ - (BUF_SIZ / 2) - CrtSwpCtl->BufferAdj;
			if(tmp > 0)
			{
				//WaitCap(BUF_SIZ - Setting.TrgPos - CrtSwpCtl->BufferAdj);
				WaitCap(BUF_SIZ - TRG_POS - CrtSwpCtl->BufferAdj);
			}
			/////////////////////////
			// end  conversion
			/////////////////////////
			//Disble ADC interrupt
			IEC0bits.AD1IE = 0;	
	
			/////////////////////////
			//get ground voltage(1)
			/////////////////////////
			//stop ADC
			AD1CON1bits.ON = 0;
			//select AN9		
			AD1CHS = MsrChnBuf[5].AdChnSelect;
			//run ADC -> conversion with out interrupt
			AD1CON1bits.ON = 1;
		}

		// get top index to display
		j = (CrntCapSys->TrgIdx - 1024 + Setting.DspTopIdx) & IDX_MSK;

		// output capture buffer
		for(i = 0;i < 256;i++)
		{
			SioOut(CrntCapSys->CapBuf[j]);
			j += Setting.DspEnsmall;
			j &= IDX_MSK;
		}

		/////////////////////////
		//get ground voltage(2)
		/////////////////////////
		//stop ADC
		AD1CON1bits.ON = 0;
		//set gnd level
		MesuredGndLevel = (ADC1BUF0 >> 2) & 0xFF;

		SioOut(Setting.DspTopIdx);
		SioOut(Setting.DspTopIdx >> 8);
		SioOut(ChnIdx);
		//ground voltage
		SioOut(MesuredGndLevel);
		SioOut(0);
		SioOut(0);
		SioOut(0);
		SioOut(0);
		SioOut(0);
		SioOut(0);		
		SioOut(100);
	}
}


